#include "doc.h"
typedef struct Filter5x5
{
int data[5][5];
int divider;
int shift;
} Filter5x5;

typedef struct Filter3x3
{
int data[5][5];
int divider;
int shift;
} Filter3x3;

void SetDocHorDot(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocVerDot(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocDotOutline(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocDot(DocObj *doc,int x,int y,int red,int green,int blue);
int FromVirX(DocObj *doc,int x);
int FromVirY(DocObj *doc,int y);
int sgn(int a);
void DocFill(DocObj *doc,unsigned long Color);
void DocFillGradientLine(DocObj *doc,int x1,int y1,int x2,int y2);
void DocFillGradientCirc(DocObj *doc,int x1,int y1,int x2,int y2);
void DocDrawHorVerLine(DocObj *doc,int ex,int ey,int lastx,int lasty);
void DocDrawHollowLine(DocObj *doc,int ex,int ey,int lastx,int lasty);
void DocDrawLine(DocObj *doc,int ex,int ey,int lastx,int lasty);
void (*DocDrawGenericLine) (DocObj *doc,int ex,int ey,int lastx,int lasty);
void SetLineDrawingHorVer();
void SetLineDrawingHollow();
void SetLineDrawingNormal();
void HandleDrawing(DocObj *doc,XEvent *event);
void HandleFillGradLine(DocObj *doc,XEvent *event);
void HandleFillGradCirc(DocObj *doc,XEvent *event);
unsigned long HandlePickCol(DocObj *doc,XEvent *event);
unsigned long HandlePickBackCol(DocObj *doc,XEvent *event);
void HandleSelectText(DocObj *doc,XEvent *event);
void HandleSelectPixel(DocObj *doc,XEvent *event);
void HandleSelectMagic(DocObj *doc,XEvent *event);
void HandleSelectRectArea(DocObj *doc,XEvent *event);
int HandleControlBox(DocObj *doc,XEvent *event);
void HandleMouseScroll(DocObj *doc,XEvent *event);
void HandleResize(DocObj *doc,XEvent *event);
Bool HandleCropImage(DocObj *doc,XEvent *event);
void HandleSelectOutline(DocObj *doc,XEvent *event);
void HandleMoveSelection(DocObj *doc,XEvent *event);
void HandleCopySelection(DocObj *doc,XEvent *event);
void HandleRotateSelection(DocObj *doc,XEvent *event);
void HandlePasteFromClipbrd(DocObj *doc,XEvent *event);
MemImage blankimage(int x,int y);
char *browse(Display *display,Window parent);
void SetItemHeight(Display *display);
void UpdateBrushDisplay(Display *display,int screen);
Window CreateBrushWindow(Display *display,int screen);
int HandleBrushWindow(Display *display,int screen,XEvent *event);
void ShowBrushWindow(Display *display,int screen);
void InitClipboard();
void FreeClipboard();
void CopyDoc(DocObj *doc);
void PasteDoc(DocObj *doc);
void PasteSelMaskFromClipbrd(DocObj *doc,int x,int y,Bool ForReal);
void UnPasteSelMaskFromClipbrd(DocObj *doc,int x,int y);
extern unsigned long(*ConvPixel) (int red,int green,int blue,int depth);
unsigned long ColFromHue(int f);
void UpdateColorWindow(Display *display,int screen);
unsigned long ColorFromHSB(int hue,int y,int x);
Window CreateColorWindow(Display *display,int screen);
int HandleColorWindow(Display *display,int screen,XEvent *event);
void ShowColorWindow(Display *display,int screen);
setwaitcurs(Display *display,Window window,int screen,Colormap cmap);
setpickcurs(Display *display,Window window,int screen,Colormap cmap);
setnormalcurs(Display *display,Window window);
void destroydoc(DocObj *doc);
void createanydocofsize(DocObj *doc,char *filename,int type,int xsize,int ysize);
void createanydoc(DocObj *doc,char *filename,int type);
InvertIm(DocObj *doc);
HorrifyIm(DocObj *doc);
BlurIm(DocObj *doc);
BlurFastIm(DocObj *doc);
SharpenRandomgoodIm(DocObj *doc);
SharpenFastIm(DocObj *doc);
Filter5x5Im(DocObj *doc,Filter5x5 filter);
Filter3x3Im(DocObj *doc,Filter3x3 filter);
SharpenSmIm(DocObj *doc);
SharpenMedIm(DocObj *doc);
SharpenCon4Im(DocObj *doc);
SharpenCon8Im(DocObj *doc);
SharpenIm(DocObj *doc);
SharpenHugeIm(DocObj *doc);
SharpenDiagIm(DocObj *doc);
HandDrawIm(DocObj *doc);
HandDrawDiagIm(DocObj *doc);
CustomEffectIm(DocObj *doc);
EmbossIm(DocObj *doc);
Sharpen1PixelIm(DocObj *doc);
MergeDocsWrapIm(DocObj *doc,DocObj *doc2,DocObj *channel);
AddDocsWrapIm(DocObj *doc,DocObj *doc2);
void rotate(int *x,int *y,double angle);
RotateIm(DocObj *doc,int xc,int yc,double angle);
StretchHistogramIm(DocObj *doc);
ShiftBrightIm(DocObj *doc,int amount);
MulBrightIm(DocObj *doc,int amount);
void GammaDocIm(DocObj *doc);
void createlocalwin(Display *display,char *title,char *icont,int XSize,int YSize);
void EnableClickAndKeys(Display *display);
void destroylocalwindow(Display *display);
void DrawDataLine(Display *display, int x,int y,int l,unsigned char *data);
char getkey(Display *display,Window window);
void ShowMessage(char *Title,char *text,Display *display);
void ask(char *prompt, char *text,Display *display);
void ShowText(char *Title,char *text,Display *display);
void dialog(char * in,char *out,char *defstr,int items,Display *display,int *minvals,int *maxvals);
void getdim(int *x,int *y,Display *display);
void getfactors(float *a,float *b,Display *display);
void getfactor(float *a,Display *display);
void getscaninfo(int *x,int *y,int *xst, int *yst, Display *display);
char ModifyText(Display *display,char *text,int x,int y,XEvent event);
void AskCustomFilter(Filter5x5 *filter,Display *display);
int guessformat(char *filename);
void PutPixelRect(DocObj *doc,int x,int y,int w,int h,unsigned long color);
void ShowImage(DocObj *doc);
unsigned long ConvPixel1 (int red,int green,int blue,int depth);
unsigned long ConvPixel8 (int red,int green,int blue,int depth);
unsigned long ConvPixel16 (int red,int green,int blue,int depth);
unsigned long ConvPixel24 (int red,int green,int blue,int depth);
unsigned long (*ConvPixel) (int red,int green,int blue,int depth);
void initpixelconvert(int depth);
unsigned long ConvLongPixel(unsigned long ColVal,int depth);
void DrawTemp(DocObj *doc,int x,int y,int red,int green,int blue);
int ColDiff(unsigned long c1,unsigned long c2);
unsigned long GetDocPixel(DocObj *doc,int x, int y);
unsigned long GetDocVirPixel(DocObj *doc,int x,int y);
void SetDocPixelNormal(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocPixelIfLighter(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocPixelIfDarker(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocPixelMergeHalf(DocObj *doc,int x,int y,int red,int green,int blue);
void (*SetDocPixelSelected) (DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocPixel(DocObj *doc,int x,int y,int red,int green,int blue);
void SetDocPixelModeNormal();
void SetDocPixelModeIfLighter();
void SetDocPixelModeIfDarker();
void SetDocPixelModeMergeHalf();
void SetDocPixelColor(DocObj *doc,int x,int y,unsigned long colordef);
void SetDocVirPixel(DocObj *doc,int x,int y,unsigned long colordef);
void UpdateWholeDocView(DocObj *doc);
void UpdateDocOrMask(DocObj *doc);
void CropSize(DocObj *doc);
void UpdateDocScrollBars(DocObj *doc);
void BringDocBarsInlimits(DocObj *doc);
void ClipWinToMax(DocObj *doc);
void ZoomOutImage(DocObj *doc);
void ZoomInImage(DocObj *doc);
void HorScroll(DocObj *doc,XEvent *event);
void VerScroll(DocObj *doc,XEvent *event);
void SetWindowSizes(DocObj *doc);
void InitializePalette(Display *display,int screen,int depth);
void LoadImage(DocObj *doc);
void ReloadImage(DocObj *doc);
void ShowDocInfo(DocObj *doc);
void ShowDocInfoAnd(DocObj *doc,char *text);
int menu(Display *display,Window parent,char entry[][20],int x,int y,int No,int direction);
void printps(char *filename,MemImage im);
MemImage readiimg(char* filename);
MemImage readjpg(char* filename);
MemImage readpcx8(char* filename);
MemImage readpcx(char *filename);
MemImage readscan(char* filename,Display* display);
void PositionReportWindow(Display *display,Window parent);
void InitReportWindow(Display *displaysrc,int screensrc,Window parent);
void ReportThat(char *str);
void CloseReportWindow();
void OpenReportWindow();
void ReportMode(int mode);
ScrollBar CreateScrollBar(Display *display,Window parent,int screen,int depth,
int x,int y,int width,int height);
void SetHorScrollBar(Display *display,ScrollBar *bar,int x,int y,int Width,int Height);
void SetVerScrollBar(Display *display,ScrollBar *bar,int x,int y,int Width,int Height);
void UpdateHorBar(Display *display,ScrollBar bar);
void UpdateVerBar(Display *display,ScrollBar bar);
int CheckBar(Display *display,ScrollBar *bar,XEvent *event,Bool HorizDir);
void ShowModeButton(Display *display,int screen);
Window CreateSelBar(Display *display,int screen);
int HandleSelBar(Display *display,int screen,XEvent *event);
void ShowSelBar(Display *display,int screen);
void CreateEmptyMask(DocObj *doc);
void ClearMask(DocObj *doc);
Bool GetMaskPixel(DocObj *doc,int x,int y);
Bool UseMaskPixel(DocObj *doc,int x,int y);
void LoadMaskOnShowPoint(DocObj *doc,int x,int y);
LoadMaskOnShowPointAccurate(DocObj *doc,int x,int y);
void SetMaskPixel(DocObj *doc,int x,int y,Bool state);
void SetMaskPixelFast(DocObj *doc,int x,int y,Bool state);
void LoadMaskOnShowImage(DocObj *doc);
void LoadMaskOnShowDoc(DocObj *doc);
void UpdateMaskActive(DocObj *doc);
void SelectRectangle(DocObj *doc,int x,int y,int w,int h);
void SelectMagic(DocObj *doc,int x,int y,int maxdiff);
void SelectMagicImage(DocObj *doc,int x,int y);
void ClipShowMask(DocObj *doc);
void SetWindowBackMask(DocObj *doc);
void DrawLineOnSelMask(DocObj *doc);
void DrawTextOnSelMask(DocObj *doc,int xp,int yp,char *text);
void DrawPolyOnSelMask(DocObj *doc,int count,int *Xp,int *Yp);
void ExpandSelMask(DocObj *doc);
void ReduceSelMask(DocObj *doc);
void InvertSelMask(DocObj *doc);
void MoveSelMask(DocObj *doc,int xd,int yd);
void CopySelMask(DocObj *doc,int xd,int yd);
void PasteSelMask(DocObj *srcdoc,DocObj *dstdoc,int xd,int yd,Bool ForReal);
void UnPasteSelMask(DocObj *srcdoc,DocObj *dstdoc,int xd,int yd);
void CropRectangle(DocObj *doc,int x,int y,int width,int height);
void ResizeDoc(DocObj *doc,DocObj *newdoc, int x,int y);
int rand_in(int a,int b);
int rand_exp(int a,int b,int divider);
TextureDiagonalCloudIm(DocObj *doc);
TextureCloudIm(DocObj *doc);
TextureFract001Im(DocObj *doc);
TextureStareogramIm(DocObj *doc);
TextureStareogramNoRandIm(DocObj *doc);
Texture3DSideIm(DocObj *doc);
void InitUndo();
void FreeUndo();
void SaveDoc(DocObj *doc);
void LoadDoc(DocObj *doc);
writeiimg(char *filename,MemImage im);
writejpg(char *filename,MemImage im);
void ReportSaveType(void);
int GetSelectedType();
void SetSelectedType(int Type);
writeselected (char *filename,MemImage im);
